\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
iferr(read("recurrence-guess.gp"),e,read("../recurrence-guess.gp"));

c=2
p=3
den=(1-c*x^p)^3
num=1
g=num/den
got=recurrence_guess_INTERNAL_gf_terms(g, 28)
\\vector(28,n,n--; (floor(n/3)+1)*2^floor(n/3) * recurrence_guess_INTERNAL_vector_modulo([1,0,0],n))
want=vector(28,n,n--; (n/3+1)*(n/3+2)/2*2^floor(n/3) * recurrence_guess_INTERNAL_vector_modulo([1,0,0],n))
got==want

\\-----------------------------------------------------------------------------
\\ vector(9,n,n--; floor(n/3))
\\ vector(9,n,n--; 1/3*n - recurrence_guess_INTERNAL_vector_modulo([0,1/3,2/3],n))
\\ vector(9,n,n--; floor(n/3)^2)
\\ vector(9,n,n--; floor(n/3)^3)
\\ (n/3 - f)^3

base=7
spread=12
sd=3
reduced_spread = spread / sd
vector(12,i,i--; base^floor(i/spread) / reduced_base^floor(i/reduced_spread))
vector(12,i,i--; (sd*floor(i/spread) - floor(i/reduced_spread)))
vector(12,i,i--; -floor(i/reduced_spread))

\\-----------------------------------------------------------------------------

\\ A163626  forward
\\ A075263  reverse

{
  for(expon=1,8,
     spread=1;
     v=vector(expon+1,e,e--; prod(j=1,e, 'x/spread + j) / e!);
     v=Vecrev(v);
     print(lindep(concat([x^expon,v])));
  );
}
